"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jsonRulesEngine = require("json-rules-engine");

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CacheControlEngineFactory = function () {
  function CacheControlEngineFactory() {
    _classCallCheck(this, CacheControlEngineFactory);
  }

  _createClass(CacheControlEngineFactory, [{
    key: "createEngine",
    value: function createEngine(rules) {
      var _this = this;

      this.rules = rules;
      this.engine = new _jsonRulesEngine.Engine();
      rules.forEach(function (rule) {
        return _this.engine.addRule(rule);
      });
    }
  }, {
    key: "getEngine",
    value: function getEngine(rules, schema) {
      if (!(0, _deepEqual2.default)(this.rules, rules)) {
        this.createEngine(rules);
      }
      return this.engine;
    }
  }]);

  return CacheControlEngineFactory;
}();

exports.default = new CacheControlEngineFactory();